#include "HelloWorldScene.h"

USING_NS_CC;

Scene* HelloWorld::createScene()
{
  // 'scene' is an autorelease object
  auto scene = Scene::create();
  
  // 'layer' is an autorelease object
  auto layer = HelloWorld::create();

  // add layer as a child to scene
  scene->addChild(layer);

  // return the scene
  return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
  //////////////////////////////
  // 1. super init first
  if ( !Layer::init() )
  {
      return false;
  }
  
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();

  spriteIn = Sprite::create();
  //auto spriteIn = Sprite::create();
  spriteIn->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.8));
  //spriteIn->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.2));
  spriteIn->setTextureRect(Rect(0, 0, 100, 100));
  spriteIn->setColor(Color3B(255, 0, 0));
  this->addChild(spriteIn);

  spriteOut = Sprite::create();
  //auto spriteOut = Sprite::create();
  spriteOut->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.5));
  spriteOut->setTextureRect(Rect(0, 0, 100, 100));
  spriteOut->setColor(Color3B(255, 0, 0));
  this->addChild(spriteOut);

  spriteInOut = Sprite::create();
  //auto spriteInOut = Sprite::create();
  spriteInOut->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.2));
  spriteInOut->setTextureRect(Rect(0, 0, 100, 100));
  spriteInOut->setColor(Color3B(255, 0, 0));
  this->addChild(spriteInOut);

  
  // タッチイベント系処理
  // イベントリスナー作成
  auto listener = EventListenerTouchOneByOne::create();
  
  // イベントに対するメソッドの設定
  listener->onTouchBegan = CC_CALLBACK_2(HelloWorld::onTouchBegan, this);
  listener->onTouchMoved = CC_CALLBACK_2(HelloWorld::onTouchMoved, this);
  listener->onTouchEnded = CC_CALLBACK_2(HelloWorld::onTouchEnded, this);
  
  // ディスパッチャーに登録
  auto dispatcher = Director::getInstance()->getEventDispatcher();
  dispatcher->addEventListenerWithSceneGraphPriority(listener, this);
    
  return true;
}

bool HelloWorld::onTouchBegan(cocos2d::Touch* touch, cocos2d::Event* event)
{
 
  
  return true;
}


void HelloWorld::onTouchMoved(cocos2d::Touch* touch, cocos2d::Event* event)
{
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();
  
  spriteIn->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.8));
  //spriteIn->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.2));
  spriteIn->setTextureRect(Rect(0, 0, 100, 100));
  spriteIn->setColor(Color3B(255, 0, 0));

  spriteOut->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.5));
  spriteOut->setTextureRect(Rect(0, 0, 100, 100));
  spriteOut->setColor(Color3B(255, 0, 0));

  spriteInOut->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.2));
  spriteInOut->setTextureRect(Rect(0, 0, 100, 100));
  spriteInOut->setColor(Color3B(255, 0, 0));
}


void HelloWorld::onTouchEnded(cocos2d::Touch *touch, cocos2d::Event *event)
{
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();
  
  auto actionIn = MoveTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.8));
  auto actionOut = MoveTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.5));
  auto actionInOut = MoveTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.2));
 
//  auto actionIn = JumpTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.8), 200, 4);
//  auto actionOut = JumpTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.5), 200, 4);
//  auto actionInOut = JumpTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.2), 200, 4);

//  auto actionIn = TintTo::create(3.0f, 0, 255, 255);
//  auto actionOut = TintTo::create(3.0f, 0, 255, 255);
//  auto actionInOut = TintTo::create(3.0f, 0, 255, 255);

  
//  auto action = JumpTo::create(3.0f, Vec2(visibleSize.width * 0.8, visibleSize.height * 0.2), 300, 2);
  
//  auto easeIn = EaseIn::create(actionIn, 3.0f);
//  spriteIn->runAction(easeIn);
//  
//  auto easeOut = EaseOut::create(actionOut, 3.0f);
//  spriteOut->runAction(easeOut);
//  
//  auto easeInOut = EaseInOut::create(actionInOut, 3.0f);
//  spriteInOut->runAction(easeInOut);


//  auto easeExponentialIn = EaseExponentialIn::create(actionIn);
//  spriteIn->runAction(easeExponentialIn);
//  
//  auto easeExponentialOut = EaseExponentialOut::create(actionOut);
//  spriteOut->runAction(easeExponentialOut);
//  
//  auto easeExponentialInOut = EaseExponentialInOut::create(actionInOut);
//  spriteInOut->runAction(easeExponentialInOut);

//  auto easeSineIn = EaseSineIn::create(actionIn);
//  spriteIn->runAction(easeSineIn);
//  
//  auto easeSineOut = EaseSineOut::create(actionOut);
//  spriteOut->runAction(easeSineOut);
//  
//  auto easeSineInOut = EaseSineInOut::create(actionInOut);
//  spriteInOut->runAction(easeSineInOut);

//  auto easeElasticIn = EaseElasticIn::create(actionIn);
//  spriteIn->runAction(easeElasticIn);
////  auto easeElasticOut = EaseElasticOut::create(actionOut, 0.5f);
//  auto easeElasticOut = EaseElasticOut::create(actionOut);
//  spriteOut->runAction(easeElasticOut);
//  
//  auto easeElasticInOut = EaseElasticInOut::create(actionInOut);
//  spriteInOut->runAction(easeElasticInOut);

//  auto easeBounceIn = EaseBounceIn::create(actionIn);
//  spriteIn->runAction(easeBounceIn);
//  
//  auto easeBounceOut = EaseBounceOut::create(actionOut);
//  spriteOut->runAction(easeBounceOut);
//  
//  auto easeBounceInOut = EaseBounceInOut::create(actionInOut);
//  spriteInOut->runAction(easeBounceInOut);
  
  auto easeBackIn = EaseBackIn::create(actionIn);
  spriteIn->runAction(easeBackIn);
  
  auto easeBackOut = EaseBackOut::create(actionOut);
  spriteOut->runAction(easeBackOut);
  
  auto easeBackInOut = EaseBackInOut::create(actionInOut);
  spriteInOut->runAction(easeBackInOut);

//  auto easeBackIn = EaseBackIn::create(action);
//  spriteIn->runAction(easeBackIn);

  
  
//  auto easeQuadraticActionIn = EaseQuadraticActionIn::create(actionIn);
//  spriteIn->runAction(easeQuadraticActionIn);
//  
//  auto easeQuadraticActionOut = EaseQuadraticActionOut::create(actionOut);
//  spriteOut->runAction(easeQuadraticActionOut);
//  
//  auto easeQuadraticActionInOut = EaseQuadraticActionInOut::create(actionInOut);
//  spriteInOut->runAction(easeQuadraticActionInOut);
  
//  auto easeQuarticActionIn = EaseQuarticActionIn::create(actionIn);
//  spriteIn->runAction(easeQuarticActionIn);
//  
//  auto easeQuarticActionOut = EaseQuarticActionOut::create(actionOut);
//  spriteOut->runAction(easeQuarticActionOut);
//  
//  auto easeQuarticActionInOut = EaseQuarticActionInOut::create(actionInOut);
//  spriteInOut->runAction(easeQuarticActionInOut);
  
//  auto easeQuinticActionIn = EaseQuinticActionIn::create(actionIn);
//  spriteIn->runAction(easeQuinticActionIn);
//  
//  auto easeQuinticActionOut = EaseQuinticActionOut::create(actionOut);
//  spriteOut->runAction(easeQuinticActionOut);
//  
//  auto easeQuinticActionInOut = EaseQuinticActionInOut::create(actionInOut);
//  spriteInOut->runAction(easeQuinticActionInOut);
  
//  auto easeCircleActionIn = EaseCircleActionIn::create(actionIn);
//  spriteIn->runAction(easeCircleActionIn);
//  
//  auto easeCircleActionOut = EaseCircleActionOut::create(actionOut);
//  spriteOut->runAction(easeCircleActionOut);
//  
//  auto easeCircleActionInOut = EaseCircleActionInOut::create(actionInOut);
//  spriteInOut->runAction(easeCircleActionInOut);

//  auto easeCubicActionIn = EaseCubicActionIn::create(actionIn);
//  spriteIn->runAction(easeCubicActionIn);
//  
//  auto easeCubicActionOut = EaseCubicActionOut::create(actionOut);
//  spriteOut->runAction(easeCubicActionOut);
//  
//  auto easeCubicActionInOut = EaseCubicActionInOut::create(actionInOut);
//  spriteInOut->runAction(easeCubicActionInOut);

}