#include "HelloWorldScene.h"

USING_NS_CC;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
  //////////////////////////////
  // 1. super init first
  if ( !Layer::init() )
  {
      return false;
  }
  
  Size visibleSize = Director::getInstance()->getVisibleSize();
  Vec2 origin = Director::getInstance()->getVisibleOrigin();

  auto sprite = Sprite::create();
  sprite->setPosition(Vec2(visibleSize.width * 0.2, visibleSize.height * 0.2));
  sprite->setTextureRect(Rect(0, 0, 200, 200));
  sprite->setColor(Color3B(255, 0, 0));

  this->addChild(sprite);
 
  auto actionMoveBy1 = MoveBy::create(2.0f, Vec2(200, 0));
  auto actionMoveBy2 = MoveBy::create(2.0f, Vec2(0, 200));
  auto actionMoveBy3 = MoveBy::create(2.0f, Vec2(-200, 0));
  auto actionMoveBy4 = MoveBy::create(2.0f, Vec2(0, -200));
  
  auto actionRotate = RotateBy::create(8.0f, 1440);
  
  auto sequence = Sequence::create(actionMoveBy1, actionMoveBy2, actionMoveBy3, actionMoveBy4, nullptr);
  auto spawn = Spawn::create(sequence, actionRotate, nullptr);
  sprite->runAction(spawn);
  
  auto spriteVec = Sprite::create();
  spriteVec->setPosition(Vec2(visibleSize.width * 0.6, visibleSize.height * 0.2));
  spriteVec->setTextureRect(Rect(0, 0, 200, 200));
  spriteVec->setColor(Color3B(255, 0, 0));
  
  this->addChild(spriteVec);

  Vector<FiniteTimeAction *> moveActions;
  moveActions.pushBack(MoveBy::create(2.0f, Vec2(200, 0)));
  moveActions.pushBack(MoveBy::create(2.0f, Vec2(0, 200)));
  moveActions.pushBack(MoveBy::create(2.0f, Vec2(-200, 0)));
  moveActions.pushBack(MoveBy::create(2.0f, Vec2(0, -200)));
  auto sequenceVec = Sequence::create(moveActions);
  
  auto actionRotateVec = RotateBy::create(8.0f, 1440);
  
  Vector<FiniteTimeAction *> spawnActions;
  spawnActions.pushBack(sequenceVec);
  spawnActions.pushBack(actionRotateVec);

  auto spawnVec = Spawn::create(spawnActions);
  
  spriteVec->runAction(spawnVec);

  return true;
}