#include "HelloWorldScene.h"

USING_NS_CC;

Scene* HelloWorld::createScene()
{
    // 'scene' is an autorelease object
    auto scene = Scene::create();
    
    // 'layer' is an autorelease object
    auto layer = HelloWorld::create();

    // add layer as a child to scene
    scene->addChild(layer);

    // return the scene
    return scene;
}

// on "init" you need to initialize your instance
bool HelloWorld::init()
{
    //////////////////////////////
    // 1. super init first
    if ( !Layer::init() )
    {
        return false;
    }
    
    auto sprite = Sprite::create("HelloWorld.png");
    Size visibleSize = Director::getInstance()->getVisibleSize();
    sprite->setPosition(Vec2(visibleSize.width / 2, visibleSize.height / 2));
    addChild(sprite);

    Vector<FiniteTimeAction *> actions;
    actions.pushBack(MoveTo::create(0.5f, Vec2(100, 100)));
    actions.pushBack(CallFunc::create(CC_CALLBACK_0(HelloWorld::actionsCallback, this)));
    Sequence *sequence = Sequence::create(actions);
    sprite->runAction(sequence);

// 6-4-2以降は以下を使います
//    auto sprite = Sprite::create("HelloWorld.png");
//    Size visibleSize = Director::getInstance()->getVisibleSize();
//    sprite->setPosition(Vec2(visibleSize.width / 2, visibleSize.height / 2));
//    addChild(sprite);
//    
//    sprite->setTag(123);
//    sprite->runAction(CallFuncN::create(CC_CALLBACK_1(HelloWorld::actionsCallback1, this)));
    
    return true;
}

void HelloWorld::actionsCallback()
{
    log("アクションが終わりました");
}

void HelloWorld::actionsCallback1(Node *sender)
{
    log("ターゲットのタグ: %d", sender->getTag());
}
